/****************************
*         astro.js          *
*   Version 1.0 19.04.2012  *
*     created by oldster    *
*    http://itheming.de/    *
****************************/
var longitude_x = obj.lat_long.split(",")[1];	// Longitude
var latitude_x = obj.lat_long.split(",")[0];	// Latitude

var mondaufgang = "";
var mondaufgangzeit = "";
var monduntergang = "";
var monduntergangzeit = "";
var sonnenaufgang = "";
var sonnenaufgangzeit = "";
var sonnenuntergang = "";
var sonnenuntergangzeit = "";

function Java_JD(Zeit){
    return Zeit / 86400000 + 2440587.5;
  }
  
  
  function CS(x){
    return Math.cos(x * .0174532925199433);
  }
  function SN(x){
    return Math.sin(x * .0174532925199433);
  }
  function AufUntergang(Modus){
    //Modus% 1 = Mond, 2 = Sonne, 3 = Dämmerung bürgerlich, 4 = Dämmerung nautisch wird hier nicht verwendet

    var Heute = new Date();
    Heute.setHours(12);
    Heute.setMinutes(0);
	 
    longitude = longitude_x * -1;
	latitude = latitude_x;
	
    var MJD = Math.floor(Java_JD(Heute.getTime())) - 2400000;
       MJD += Heute.getTimezoneOffset() / 1440;
	   
	

    var sphi = SN(latitude);
    var cphi = CS(latitude);
    var Auf;
    var Unter;
    var sinho;
    switch(Modus){
      case 1:
        sinho = SN(8 / 60);  //Mond
        break;
      case 2:
        sinho = SN(-50 / 60); //Sonne
        break;
      case 3:
        sinho = SN(-6);  //Dämmerung bürgerlich (-6)
        break;
      case 4:
        sinho = SN(-12);   //Dämmerung nautische (-12))
        break;
    }
	
    var RiseSet = AufUnterBerechnung(Modus, MJD, longitude, latitude, sphi, cphi, sinho); //return [utrise, utset, above];
	
    
    var AMinute = (RiseSet[0] - Math.floor(RiseSet[0])) * 60 / 100;
    if(AMinute >= .595){
      AMinute = 0;
      RiseSet[0] += 1;
    }
    var Aufgang = Math.floor(RiseSet[0]) + AMinute;
    if(Aufgang != 0){
      Auf = Aufgang.toFixed(2);
    }
    else{
      Auf = "--:-- ";
    }
    var UMinute = (RiseSet[1] - Math.floor(RiseSet[1])) * 60 / 100;
    if(UMinute >= .595){
      UMinute = 0;
      RiseSet[1] += 1;
    }
    var Untergang = Math.floor(RiseSet[1]) + UMinute;
    if(Untergang != 0){
      Unter = Untergang.toFixed(2);
     }
    else{
      Unter = "--:-- ";
    }
    if(Aufgang == 0 && Untergang == 0){
      if(Modus == 3){
        if(RiseSet[2] == 1){
          Auf = "immer";
          Unter = " hell";
        }
        else{
          Auf = "immer";
          Unter = " dunkel";
        }
      }
      else{
        Unter = " sichtbar"
        if(RiseSet[2] == 1){
          Auf = "immer";
        }
        else{
          Auf = "nicht";
        }
      }
    }
	return [Auf, Unter];
   }
  function AufUnterBerechnung(Modus, MJD, longitude, latitude, sphi, cphi, sinho){
	  
    /*
    Modus=1 = Mond Modus>1 = Sonne
    utrise = Aufgang Mod. Scalicer Dez.
    utset = Untergang Mod. Scalicer Dez.
    above=1 = immer sichtbar, above=0 immer dunkel
    */
    var Hour = 1;
    var yminus, yo, yplus;
    var QuatRet = new Array(3);
    var utrise = 0, utset = 0, above;
    do {
      yminus = SINALT(Modus, MJD, Hour - 1, longitude, cphi, sphi) - sinho;
      if(yminus > 0){
        above = 1;
      }
      else{
        above = 0;
      }
      yo = SINALT(Modus, MJD, Hour, longitude, cphi, sphi) - sinho;
      yplus = SINALT(Modus, MJD, Hour + 1, longitude, cphi, sphi) - sinho;
      QuatRet = QUAD(yminus, yo, yplus); // QuatRet 0 = ye, 1 = zero1, 2 = zero2, 3 = nz
      if(QuatRet[3] == 1){
        if(yminus < 0){
          utrise = Hour + QuatRet[1];
        }
        else{
          utset = Hour + QuatRet[1];
        }
      }
      if(QuatRet[3] == 2){
        if(QuatRet[0] < 0){
          utrise = Hour + QuatRet[2];
          utset = Hour + QuatRet[1];
        }
        else{
          utrise = Hour + QuatRet[1];
          utset = Hour + QuatRet[2];
        }
      }
      yminus = yplus;
      Hour = Hour + 2;

   } while(Hour < 25 && (utrise == 0 || utset == 0));
   
   
   return [utrise, utset, above];
}
  function SINALT(Modus, MJD, Hour, longitude, cphi, sphi){
    var MJDO = MJD + Hour / 24;
    var t = (MJDO - 51544.5) / 36525;
    if(Modus == 1){
      var decra = Mondberechnung(t);
    }
    else{
      var decra = Sonnenberechnung(t);
    }
    var tau = 15 * (LMST(MJDO, longitude) - decra[1]);
    return sphi * SN(decra[0]) + cphi * CS(decra[0]) * CS(tau);
  }
  function LMST(MJD, longitude){
    var MJDO = Math.floor(MJD);
    var ut = (MJD - MJDO) * 24;
    var t = (MJDO - 51544.5) / 36525;
    var gmst = 6.697374558 + 1.0027379093 * ut + (8640184.812866 + (.093104 - .0000062 * t) * t) * t / 3600;
    return 24 * FRAK((gmst - longitude / 15) / 24);
  }
  function FRAK(x){
    x = x - parseInt(x);
    if(x < 0)
      x += 1;
    return x;
  }
  function Mondberechnung(t){
    var p2 = 6.283185307;
    var arc = 206264.8062;
    var coseps = .91748;
    var sineps = .39778;
    var lo = FRAK(.606433 + 1336.855225 * t);
    var l = p2 * FRAK(.374897 + 1325.55241 * t);
    var ls = p2 * FRAK(.993133 + 99.997361 * t);
    var d = p2 * FRAK(.827361 + 1236.853086 * t);
    var f = p2 * FRAK(.259086 + 1342.227825 * t);
    var dl = 22640 * Math.sin(l) - 4586 * Math.sin(l - 2 * d) + 2370 * Math.sin(2 * d) + 769 * Math.sin(2 * l) - 668 * Math.sin(ls) - 412 * Math.sin(2 * f) - 212 * Math.sin(2 * l - 2 * d) - 206 * Math.sin(l + ls - 2 * d) + 192 * Math.sin(l + 2 * d) - 165 * Math.sin(ls - 2 * d) - 125 * Math.sin(d) - 110 * Math.sin(l + ls) + 148 * Math.sin(l - ls) - 55 * Math.sin(2 * f - 2 * d);
    var s = f + (dl + 412 * Math.sin(2 * f) + 541 * Math.sin(ls)) / arc;
    var h = f - 2 * d;
    var n = -526 * Math.sin(h) + 44 * Math.sin(l + h) - 31 * Math.sin(-l + h) - 23 * Math.sin(ls + h) + 11 * Math.sin(-ls + h) - 25 * Math.sin(-2 * l + f) + 21 * Math.sin(-l + f);
    var lmoon = p2 * FRAK(lo + dl / 1296000);
    var bmoon = (18520 * Math.sin(s) + n) / arc;
    var cb = Math.cos(bmoon);
    var x = cb * Math.cos(lmoon);
    var v = cb * Math.sin(lmoon);
    var w = Math.sin(bmoon);
    var y = coseps * v - sineps * w;
    var z = sineps * v + coseps * w;
    var rho = Math.sqrt(1 - z * z);
    var dec = (360 / p2) * Math.atan(z / rho);
    var ra = (48 / p2) * Math.atan(y / (x + rho));
    if(ra < 0){
      ra += 24;
    }
    return [dec, ra];
  }
  function Sonnenberechnung(t){
    var p2 = 6.283185307;
    var coseps = .91748;
    var sineps = .39778;
    var m = p2 * FRAK(.993133 + 99.997361 * t);
    var dl = 6893 * Math.sin(m) + 72 * Math.sin(2 * m);
    var l = p2 * FRAK(.7859453 + m / p2 + (6191.2 * t + dl) / 1296000);
    var sl = Math.sin(l);
    var x = Math.cos(l);
    var y = coseps * sl;
    var z = sineps * sl;
    var rho = Math.sqrt(1 - z * z);
    var dec = (360 / p2) * Math.atan(z / rho);
    var ra = (48 / p2) * Math.atan(y / (x + rho))
    if(ra < 0)
      ra += 24;
    return [dec, ra];
  }
  function QUAD(yminus, yo, yplus){
    var nz = 0;
    var a = .5 * (yminus + yplus) - yo;
    var b = .5 * (yplus - yminus);
    var c = yo;
    var xe = -b / (2 * a);
    var ye = (a * xe + b) * xe + c;
    var dis = b * b - 4 * a * c;
    if(dis >= 0){
      var dx = .5 * Math.sqrt(dis) / Math.abs(a);
      var zero1 = xe - dx;
      var zero2 = xe + dx;
      if(Math.abs(zero1) <= 1){
        nz += 1;
      }
      if(Math.abs(zero2) <= 1){
        nz += 1;
      }
      if(zero1 < -1){
        zero1 = zero2;
      }
    }
    return [ye, zero1, zero2, nz];
  }
  
  function AufUnterAusgabe(){
    var AufUnter = new Array(1);
    AufUnter = AufUntergang(1);
    var Jetzt = new Date();
    var Test = Jetzt.getHours() + Jetzt.getMinutes() / 100;

    if(AufUnter[0] == "immer" || AufUnter[0] == "nicht"){
      mondaufgang = "Der Mond ist heute";
	  mondaufgangzeit = AufUnter[0];
      monduntergang = AufUnter[1];
      monduntergangzeit = "";
    }
    else{
      mondaufgang = "Mondaufgang ist um";
      if(Test > AufUnter[0]){
        mondaufgang = mondaufgang.replace(/ist/,"war");
      }
      mondaufgangzeit = AufUnter[0];
      monduntergang = "Monduntergang ist um";
      if(Test > AufUnter[1]){
        monduntergang = monduntergang.replace(/ist/,"war");
      }
      monduntergangzeit = AufUnter[1];
    }
    AufUnter = AufUntergang(2);
    if(AufUnter[0] == "immer" || AufUnter[0] == "nicht"){
      sonnenaufgang = "Die Sonne ist heute";
      sonnenaufgangzeit = AufUnter[0];
      sonnenuntergang = AufUnter[1];
      sonnenuntergangzeit = "";
    }
    else{
      sonnenaufgang = "Sonnenaufgang ist um";
      if(Test > AufUnter[0]){
        sonnenaufgang = sonnenaufgang.replace(/ist/,"war");
      }
      sonnenaufgangzeit = AufUnter[0];
      sonnenuntergang = "Sonnenuntergang ist um";
      if(Test > AufUnter[1]){
        sonnenuntergang = sonnenuntergang.replace(/ist/,"war");
      }
      sonnenuntergangzeit = AufUnter[1];
    }
	
		
  }
  